﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Recurso_Administrativo.Persistencia;


/******************************************************************************************************************************
 *   Nombre: CCDDServicio
 *   Fecha: 07/11/2011
 *   Descripción: Clase que se conectá a la base de datos y realizará consultas para cargar los Centros Directivos
 *   Autor: José Juan Alvarado Almenara
 ******************************************************************************************************************************/

namespace Recurso_Administrativo.Clases
{
    partial class CCDDServicio
    {
        LinqDBDataContext dc = new LinqDBDataContext();

        //Obtener todos los CCDD // 

        internal List<TS_CENTRODIRECTIVO> getCCDD()
        {
            var ccdd = from u in dc.TS_CENTRODIRECTIVO
                       select u;
            return ccdd.ToList();
        }

        //Obtenter el CCDD consultando por su clave // 

        internal TS_CENTRODIRECTIVO getCCDD(int ID)
        {
            var ccdd = from u in dc.TS_CENTRODIRECTIVO
                       where u.CD_CLAVE == ID
                       select u;
            if (ccdd.Count() > 0)
                return ccdd.First();
            else
                return null;
        }
    }
}
