﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Recurso_Administrativo.Persistencia;

/***********************************************************************************************************************************
 *   Nombre: ExpedienteF3Servicio
 *   Fecha: 22/11/2011 (San Prosdócimo de Padua)
 *   Descripción: Clase se que encargará por medio de los diferentes métodos implementados, realizar las consultas, insercciones y 
 *   actualizaciones a la tabla de Expedientes en la fase 3.
 *   Autor: José Juan Alvarado Almenara
 ***********************************************************************************************************************************/


namespace Recurso_Administrativo.Clases
{
    public class ExpedienteF3Servicio
    {
        LinqDBDataContext dc = new LinqDBDataContext(); //Conexión a la BBDD

         internal T_EXPEDIENTE_F3 GetExpF3(int ID)
        {
            
             var exp3 = from u in dc.T_EXPEDIENTE_F3
                       where u.EF3_EF1_CF == ID
                       select u;
             if(exp3.Count() > 0)
                 return exp3.First();
             else
                 return null;
         }

         /*************************************************************************************************************************
        * Metodo: AddExpediente
        * Recibe: Objeto T_Expediente_F3 a añadir a la tabla
        * Devuelve: 
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011
        * Descripcion: Añadimos un nuevo expediente a la base de datos
        *************************************************************************************************************************/

         internal void AddExpediente(T_EXPEDIENTE_F3 _expF3)
         {
             dc.T_EXPEDIENTE_F3.InsertOnSubmit(_expF3);
             dc.SubmitChanges();
         }

         /*************************************************************************************************************************
        * Metodo: ActualizarExpF3
        * Recibe: 
        * Devuelve: 
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011
        * Descripcion: Actilizar el registro en la Tabla T_Expediente_F3 con el que estamos trabajando.
        *************************************************************************************************************************/

         internal void ActualizarExpF3()
         {
             dc.SubmitChanges();
         }
    }
}