﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Recurso_Administrativo.Persistencia;

/***********************************************************************************************************************************
 *   Nombre: ProvinciaServicio
 *   Fecha:12/11/2011
 *   Descripción: Clase se que encargará por medio de los diferentes métodos implementados, realizar las consultas a las tablas de 
 *   provincia y municipios para cargar los combos.
 *   Autor: José Juan Alvarado Almenara
 ***********************************************************************************************************************************/

namespace Recurso_Administrativo.Clases
{
    partial class ProvinciaServicio
    {
         LinqDBDataContext dc = new LinqDBDataContext();

        // Obtenemos todas las provincias //
        internal List<TS_PROVINCIA> getProvincias()
        {
            var prv = from u in dc.TS_PROVINCIA
                      select u;
            return prv.ToList();
        }

        //Obtenemos todos los municipios
        internal List<TS_MUNICIPIO> getMunicipios()
        {
            var mun = from u in dc.TS_MUNICIPIO
                      select u;
            return mun.ToList();
        }

        //Obtenemos la provincia atendiendo a su clave
        internal List<TS_PROVINCIA> getProvincias(int clave)
        {
            var prv = from u in dc.TS_PROVINCIA
                      where u.PR_CLAVE == clave
                      select u;
            return prv.ToList();
        }

        //Obtemos los municipios que pertenecen a una determinada provincia

        internal List<TS_MUNICIPIO> getMunicipios(int prov)
        {
            var mun = from u in dc.TS_MUNICIPIO
                      where u.MU_PR_CF == prov
                      select u;
            return mun.ToList();
        }
    }
}
