﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Recurso_Administrativo.Persistencia;
using Recurso_Administrativo.Clases;

namespace Recurso_Administrativo
{
    /***********************************************************************************************************************************
     *   Nombre: Consulta
     *   Fecha: 28/11/2011 (San Santiago de la Marca) 
     *   Descripción: Esta ventana será la encargada de mostrar los campos por los que se pueden realizar consultas y de recoger los
     *   datos de dicha consulta.
     *   Autor: José Juan Alvarado Almenara
     *********************************************************************************************************************************/

    public partial class Consultas : Window
    {
        // Creamos los objetos globales que serán usados por la clase //
        ConsultaServicio _conSrv = new ConsultaServicio();
        List<V_Todos> listCons = new List<V_Todos>();
        List<ExpedienteGrid> listExpGrid = new List<ExpedienteGrid>();
        TipoRecursoServicio _tipRecSrv = new TipoRecursoServicio();
        TS_TIPORECURSO _tipRec = new TS_TIPORECURSO();
        TS_CENTRODIRECTIVO _CCDD = new TS_CENTRODIRECTIVO();
        TS_DESESTIMACIONES _tipDes = new TS_DESESTIMACIONES();
        TS_SENTIDOINFORME _senInf = new TS_SENTIDOINFORME();

        bool[] cond = new bool[8]; // Controlar que condiciones de consulta han sido seleccionadas

        public Consultas()
        {
            InitializeComponent();
            listCons = _conSrv.GetExpediente();
            
        }

        // Comprobamos cuales de los CheckBox han sido seleccionados o deseleccionados y habilitando o deshabilitando
        // su correspondiente campo asociado de recogida de información //
        private void chbExp_Checked(object sender, RoutedEventArgs e)
        {
            txtNExp.IsEnabled = true;
            txtNExp.Focus();
            cond[0] = true;    
        }

        private void chbExp_Unchecked(object sender, RoutedEventArgs e)
        {
            txtNExp.IsEnabled = false;
            txtNExp.Text = "";
            cond[0] = false;
        }

        private void chbTipRec_Checked(object sender, RoutedEventArgs e)
        {
            cmbTipRec.IsEnabled = true;
            CargarCmdTipRec();
            cmbTipRec.Focus();
            cond[1] = true;
        }


        private void chbTipRec_Unchecked(object sender, RoutedEventArgs e)
        {
            cmbTipRec.IsEnabled = false;
            cmbTipRec.SelectedIndex = -1;
            cond[1] = false;
        }

        private void chbCCDD_Checked(object sender, RoutedEventArgs e)
        {
            cmbCCdd.IsEnabled = true;
            CargarCmbCCDD();
            cmbCCdd.Focus();
            cond[2] = true;
        }

        private void chbCCDD_Unchecked(object sender, RoutedEventArgs e)
        {
            cmbCCdd.IsEnabled = false;
            cmbCCdd.SelectedIndex = -1;
            cond[2] = false;
        }

        private void chbFecIni_Checked(object sender, RoutedEventArgs e)
        {
            dtpFecIni.IsEnabled = true;
            dtpFecIni.Focus();
            cond[3] = true;
        }

        private void chbFecIni_Unchecked(object sender, RoutedEventArgs e)
        {
            dtpFecIni.IsEnabled = false;
            cond[3] = false;
        }

        private void chbEstExp_Checked(object sender, RoutedEventArgs e)
        {
            cmbEstExp.IsEnabled = true;
            CargarCmbEstExp();
            cmbEstExp.Focus();
            cond[4] = true;
        }

        private void chbEstExp_Unchecked(object sender, RoutedEventArgs e)
        {
            cmbEstExp.IsEnabled = false;
            cmbEstExp.SelectedIndex = -1;
            cond[4] = false;
        }
        
        private void chbSenInf_Checked(object sender, RoutedEventArgs e)
        {
            cmbSenInf.IsEnabled = true;
            CargarCmbSenInf();
            cmbSenInf.Focus();
            cond[5] = true;
        }

        private void chbSenInf_Unchecked(object sender, RoutedEventArgs e)
        {
            cmbSenInf.IsEnabled = false;
            CargarCmbSenInf();
            cond[5] = false;
        }

        private void chbNifRec_Checked(object sender, RoutedEventArgs e)
        {
            txtNIFRec.IsEnabled = true;
            txtNIFRec.Focus();
            cond[6] = true;
        }

        private void chbNifRec_Unchecked(object sender, RoutedEventArgs e)
        {
            txtNIFRec.Text = "";
            txtNIFRec.IsEnabled = false;
            cond[6] = false;
        }

        private void chbNifRep_Checked(object sender, RoutedEventArgs e)
        {
            txtNIFRep.IsEnabled = true;
            txtNIFRep.Focus();
            cond[7] = true;
        }

        private void chbNifRep_Unchecked(object sender, RoutedEventArgs e)
        {
            txtNIFRep.Text = "";
            txtNIFRep.IsEnabled = false;
            cond[7] = false;
        }


        /**********************************************************************************************************************
         * Metodos para cargar los combos por los que se puede realizar las consultas
         * *******************************************************************************************************************/

        private void CargarCmdTipRec()
        {
            TipoRecursoServicio _tipRecSrv = new TipoRecursoServicio();

            cmbTipRec.ItemsSource = _tipRecSrv.getTipRec();
            cmbTipRec.SelectedValue = "TR_CLAVE";
            cmbTipRec.DisplayMemberPath = "TR_DESC";
        }

        private void CargarCmbCCDD()
        {
            CCDDServicio _ccddSrv = new CCDDServicio();

            cmbCCdd.ItemsSource = _ccddSrv.getCCDD();
            cmbCCdd.SelectedValue = "CD_CLAVE";
            cmbCCdd.DisplayMemberPath = "CD_DESC";
        }

        private void CargarCmbEstExp()
        {
            TipoEstExpSer _tipEstExpSrv = new TipoEstExpSer();

            cmbEstExp.ItemsSource = _tipEstExpSrv.getDesAll();
            cmbEstExp.SelectedValue = "DE_CLAVE";
            cmbEstExp.DisplayMemberPath = "DE_DESC";
        }

        private void CargarCmbSenInf()
        {
            SentInfServ _senInfSrv = new SentInfServ();

            cmbSenInf.ItemsSource = _senInfSrv.getSentInf();
            cmbSenInf.SelectedValue = "SI_CLAVE";
            cmbSenInf.DisplayMemberPath = "SI_DESC";
        }

        /*************************************************************************************************************************
         * Evento: btnFind_Click
         * Autor: José Juan Alvarado Almenara
         * Fecha: 28/11/2011 (San Santiago de la Marca) 
         * Descripcion: Al pulsr el boton de buscar llamamos al metodo para cargar el grid con los datos por los que se desea reali-
         * zar la consulta. 
         *************************************************************************************************************************/

        private void btnFind_Click(object sender, RoutedEventArgs e)
        {
            CargarGrid();
        }

        /*************************************************************************************************************************
        * Metodo: CargarGrid
        * Recibe: 
        * Devuelve:   
        * Autor: José Juan Alvarado Almenara
        * Fecha: 28/11/2011 (San Santiago de la Marca) 
        * Descripcion: Este método se encargará de realizar la busqueda del registro atendiendo a los campos por los que se desea
         * realizar la consulta.
        *************************************************************************************************************************/

        private void CargarGrid()
        {
            ExpedienteGrid _expGrid;
            TercerosServicio _terSev = new TercerosServicio();
            
            
            int i;
            bool[] sw = new bool[8];
            bool sw2;


            dtgListExp.ItemsSource = null;  // Limpiar el datagrid
            listExpGrid.Clear(); // Limpiar la lista
            lblError.Visibility = Visibility.Hidden;

            foreach(V_Todos _expCon in listCons)
            {
                if (cond[0])  // Comprobamos quieren consultar por el nº de expediente
                {
                    if (_expCon.EF1_NUMREG .ToUpper().Trim() == txtNExp.Text.ToUpper().Trim()) // si coinciden
                        sw[0] = true;
                }
                if (cond[1]) // Comprobamos quieren consultar por el tipo recurso
                {
                    if (_expCon.EF1_TR_CF == _tipRec.TR_CLAVE)
                        sw[1] = true;
                }
                if (cond[2]) // Comprobamos quieren consultar por el Centro Directivo
                {
                    if (_expCon.EF1_CD_CF == _CCDD.CD_CLAVE)
                        sw[2] = true;
                }
                if (cond[3]) // Comprobamos quieren consultar por la fecha de inicio
                {
                    if (_expCon.EF1_FECINI == dtpFecIni.SelectedDate)
                        sw[3] = true;
                }
                if (cond[4]) // Comprobamos quieren consultar por estado expedient
                {
                    if (_expCon.EF2_DE_CF == _tipDes.DE_CLAVE)
                        sw[4] = true;
                }
                if (cond[5]) // Comprobamos quieren consultar sentido informe
                {
                    if (_expCon.EF3_SI_CF == _senInf.SI_CLAVE)
                        sw[5] = true;
                }
                if (cond[6]) // Comprobamos quieren consultar por el recurrente
                {
                    if (_expCon.EF1_TER_REC_CF == _terSev.geIDfTercero(txtNIFRec.Text))
                        sw[6] = true;
                }
                if (cond[7])  // Comprobamos quieren consultar por el representante
                {
                    if (_expCon.EF1_TER_REP_CF == _terSev.geIDfTercero(txtNIFRep.Text))
                        sw[7] = true;
                }

                i = 0;
                sw2 = false;
                // Si son ciertas la condición y se ha encontrado el registro buscado
                while (!(sw2) && (i <=7))
                {
                    if (cond[i])
                    {
                        if (sw[i])
                            sw2 = true;
                        else
                            sw2 = false;
                    }
                        i++;
                }
                if ((sw2))
                {
                    _expGrid = new ExpedienteGrid()
                    {
                        ID = _expCon.EF1_CLAVE,
                        Expediente = _expCon.EF1_NUMREG,
                        Fecha_Entrada = Convert.ToDateTime(_expCon.EF1_FECINI),
                        Tipo_Recurso = _tipRecSrv.getTipRec(_expCon.EF1_TR_CF),
                    };
                    listExpGrid.Add(_expGrid);
                }
                for (int j = 0; j <= 7; j++) // inicializamos el array de localizado a falso para la siguiente consulta
                    sw[j] = false;
            }
            if (listExpGrid.Count() > 0) // Si hemos encotrado al menos un expediente.
            {
                dtgListExp.ItemsSource = listExpGrid;
                tabResul.Focus();
            }
            else
            {
                lblError.Content = "No se han encontrado expediente/s antendiendo a los parametros consultados";
                lblError.Visibility = Visibility.Visible;
            }
        }

        // Controlar la selección de los diferentes combos //
        
        private void cmbTipRec_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            _tipRec = (TS_TIPORECURSO)cmbTipRec.SelectedItem;
        }

        private void cmbCCdd_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            _CCDD = (TS_CENTRODIRECTIVO)cmbCCdd.SelectedItem;
        }

        private void cmbEstExp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            _tipDes = (TS_DESESTIMACIONES)cmbEstExp.SelectedItem;
        }

        private void cmbSenInf_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            _senInf = (TS_SENTIDOINFORME)cmbSenInf.SelectedItem;
        }


        /*************************************************************************************************************************
        * Evento: dtgListExp_SelectionChanged
        * Autor: José Juan Alvarado Almenara
        * Fecha: 28/11/2011 (San Santiago de la Marca)
        * Descripcion: Recogemos el registro seleccionado en el grid y llamamos a la pantalla de mostrar los datos
        *************************************************************************************************************************/

        private void dtgListExp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            V_Todos _expCon = new V_Todos();
            ExpedienteGrid _expGrid = new ExpedienteGrid();

            try
            {
                _expGrid = (ExpedienteGrid)dtgListExp.CurrentItem;
                if (_expGrid != null)
                {
                    _expCon = listCons.Find(x => x.EF1_CLAVE == _expGrid.ID);

                    App.Current.Properties["ExpCon"] = _expCon;
                    ResulConsulta _WResCon = new ResulConsulta();
                    _WResCon.ShowDialog();
                    _WResCon.Owner = this;
                }
            }
            catch
            {
                CargarGrid();
            }
        }

        private void tabCon_GotFocus(object sender, RoutedEventArgs e)
        {
            btnFind.Visibility = Visibility.Visible;
        }

        private void tabResul_GotFocus(object sender, RoutedEventArgs e)
        {
            btnFind.Visibility = Visibility.Hidden;
        }
    }
}