﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Recurso_Administrativo.Clases;
using Recurso_Administrativo.Persistencia;

namespace Recurso_Administrativo
{
    /***********************************************************************************************************************************
     *   Nombre: Fase 3
     *   Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
     *   Descripción: Esta ventana se encargará de la recogida de los datos correspondientes a la fase 3
     *   Autor: José Juan Alvarado Almenara
     *********************************************************************************************************************************/

    public partial class Fase3 : Window
    {
        // Creamos los objetos globales que serán usados por la clase //
        ExpedienteF1Servicio _expF1Sev = new ExpedienteF1Servicio();
        ExpedienteF2Servicio _expF2Sev = new ExpedienteF2Servicio();
        ExpedienteF3Servicio _expF3Sev = new ExpedienteF3Servicio();

        T_EXPEDIENTE_F2 _expF2 = new T_EXPEDIENTE_F2();
        T_EXPEDIENTE_F3 _expF3 = new T_EXPEDIENTE_F3();
        TS_SENTIDOINFORME _senInf;
        bool bolExiste; // variable booleana para determinar si ya existe el exp en la tabla

        public Fase3()
        {
            InitializeComponent();
            CargarGrid();
        }


        /*************************************************************************************************************************
        * Metodo: CargarGrid
        * Recibe:
        * Devuelve:  
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Método para cargar el grid con los expedientes pendientes que se encuentran en la Fase 3
        *************************************************************************************************************************/

        private void CargarGrid()
        {
            Usuario _usr = new Usuario();
            _usr = (Usuario)App.Current.Properties["Usurario"];
            if (_expF2Sev.GetExpF3() != null)
                dtgListExp.ItemsSource = _expF2Sev.GetExpF3().ToList();
        }

        /*************************************************************************************************************************
        * Metodo: dtgListExp_SelectionChanged
        * Autor: José Juan Alvarado Almenara
        * Fecha: 21/11/2011 (San Gelasio I)
        * Descripcion: Evento que recogerá el expediente seleccionado en el grid.
        *************************************************************************************************************************/

        private void dtgListExp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ExpedienteGrid _expGrid = new ExpedienteGrid();
            try // si seleccionamos una row vacia
            {
                _expGrid = (ExpedienteGrid)dtgListExp.CurrentItem;
                if (_expGrid != null)
                {
                    CargarDatos(_expGrid);
                }

            }
            catch
            {
                CargarGrid(); //volvemos a recargar el grid
            }
        }


        /*************************************************************************************************************************
        * Metodo: CargarDatos
        * Recibe: Objeto ExpedienteGrid
        * Devuelve:   
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Método para los datos del expediente y mostrarlos por pantalla después de haber sido seleccionado en el grid
        *************************************************************************************************************************/

        private void CargarDatos(ExpedienteGrid _expGrid)
        {
            CCDDServicio _ccddSrv = new CCDDServicio();
            TS_CENTRODIRECTIVO _ccdd = new TS_CENTRODIRECTIVO();
            TercerosServicio _terSrv = new TercerosServicio();
            T_EXPEDIENTE_F1 _expF1 = new T_EXPEDIENTE_F1();
            T_EXPEDIENTE_F3 _expF3_aux = new T_EXPEDIENTE_F3();
            T_TERCEROS _tercRec = new T_TERCEROS();
            T_TERCEROS _tercRep = new T_TERCEROS();

            bolExiste = false;
            LimpiarPantalla();
            _expF1 = _expF1Sev.GetExpedienteF1(_expGrid.ID);
            _expF2 = _expF2Sev.GetRegistro(_expGrid.ID);
            if(_expF3Sev.GetExpF3(_expGrid.ID) != null)
                 _expF3 = _expF3Sev.GetExpF3(_expGrid.ID);
            _expF3_aux = _expF3Sev.GetExpF3(_expGrid.ID);
            _tercRec = _terSrv.getTerceroId(Convert.ToInt32(_expF1.EF1_TER_REC_CF));
            _tercRep = _terSrv.getTerceroId(Convert.ToInt32(_expF1.EF1_TER_REP_CF));
            _ccdd = _ccddSrv.getCCDD(Convert.ToInt32(_expF1.EF1_CD_CF));


            txtNReg.Text = _expGrid.Expediente;
            txtNifRep.Text = _tercRep.TER_NIF;
            txtNifRecur.Text = _tercRec.TER_NIF;
            txtFecEntCCDD.Text = _ccdd.CD_DESC;
            dtpEntSGT.SelectedDate = Convert.ToDateTime(_expF2.EF2_FECSOLINFLET);
            CargarCombo();
            //Si no es una nueva alta del expediente en la Fase 3
            if (_expF3_aux != null)
            {
                bolExiste = true;
                if (_expF3_aux.EF3_SI_CF != 0)
                {
                    cmbSenInf.SelectedIndex = Convert.ToInt32(_expF3_aux.EF3_SI_CF) - 1;
                    cmbSenInf.IsEnabled = false;
                }
                if (_expF3_aux.EF3_FECENVINF != null)
                {
                    dtpEnvInfCCDD.SelectedDate = Convert.ToDateTime(_expF3_aux.EF3_FECENVINF);
                    dtpEnvInfCCDD.IsHitTestVisible = false;
                    txtNRegInt.Text = _expF3_aux.EF3_NREG;
                    txtNRegInt.IsReadOnly = true;
                }
                if (_expF3.EF3_FECRECCD != null)
                {
                    dtpRecInfCCDD.SelectedDate = Convert.ToDateTime(_expF3_aux.EF3_FECRECCD);
                    dtpRecInfCCDD.IsHitTestVisible = false;
                }
                if (_expF3.EF3_FECEVORDCONS != null)
                {
                    dtpOrdCon.SelectedDate = Convert.ToDateTime(_expF3_aux.EF3_FECEVORDCONS);
                    dtpOrdCon.IsHitTestVisible = false;
                }
                if (_expF3.EF3_FECFIRMACONS != null)
                {
                    dtpFirCons.SelectedDate = Convert.ToDateTime(_expF3_aux.EF3_FECFIRMACONS);
                    dtpFirCons.IsHitTestVisible = false;
                }
            }
        }

        /*************************************************************************************************************************
        * Metodo: CargarCombo
        * Recibe: Objeto ExpedienteGrid
        * Devuelve:   
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Método usado para cargar los datos de la tabla de sentido del informe en el combo.
        *************************************************************************************************************************/

        private void CargarCombo()
        {
            SentInfServ _SenInfSrv = new SentInfServ();

            cmbSenInf.ItemsSource = _SenInfSrv.getSentInf().ToList();
            cmbSenInf.SelectedValue = "SI_CLAVE";
            cmbSenInf.DisplayMemberPath = "SI_DESC";
        }

        /*************************************************************************************************************************
        * Metodo: cmbSenInf_SelectionChanged
        * Autor: José Juan Alvarado Almenara
        * Fecha: 21/11/2011 (San Gelasio I)
        * Descripcion: Evento para recoger el sentido del informe seleccionado en el combo.
        *************************************************************************************************************************/

        private void cmbSenInf_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            _senInf = (TS_SENTIDOINFORME)cmbSenInf.SelectedValue;
        }

        /*************************************************************************************************************************
        * Metodo: btnSend_Click
        * Autor: José Juan Alvarado Almenara
        * Fecha: 21/11/2011 (San Gelasio I)
        * Descripcion: Evento que se activará al pulsar el botón de grabar, comproborá lo que se ha introducido y lo grabará.
        *************************************************************************************************************************/

        private void btnSend_Click(object sender, RoutedEventArgs e)
        {
            string mess = "";

           if((validar()) && (validar2()))  // Ha pasado las validaciones 1 y 2
           {
               if (validar3()) // Ha pasado la validación 3
               {
                   if (!bolExiste) //Es alta en la tabla
                   {
                       _expF3.EF3_EF1_CF = _expF2.EF2_EF1_CF;
                       try
                       {
                           _expF3Sev.AddExpediente(_expF3);
                           mess = "Se ha guardado";
                       }
                       catch
                       {
                           mess = "No se ha podido guardar";
                       }
                   }
                   else  // es actualización
                   {
                       try
                       {
                           _expF3Sev.ActualizarExpF3();
                           mess = "Se han guardado los cambios";
                       }
                       catch
                       {
                           mess = "No se ha podido guardar los cambios";
                       }
                   }
                   MessageBox.Show(mess, "Advertencia", MessageBoxButton.OK, MessageBoxImage.Exclamation);
               }
               LimpiarPantalla();
               CargarGrid();
           }
            
        }

        /*************************************************************************************************************************
        * Metodo: validar
        * Recibe: boolean
        * Devuelve:   
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Este método se encarga de validar los datos introduccidos en la ventana en la primera parte de dicha ventana
        *************************************************************************************************************************/

        private bool validar()
        {
            string mess = "";
            bool sw = false;
            
            if((_senInf.SI_CLAVE > 0))
            {
                _expF3.EF3_SI_CF = _senInf.SI_CLAVE; 
                if (dtpEnvInfCCDD.SelectedDate != null)
                {
                    if ((dtpEnvInfCCDD.SelectedDate <= DateTime.Today) && (dtpEnvInfCCDD.SelectedDate >= _expF2.EF2_FECSOLINFLET))
                    {
                        if (txtNRegInt.Text != "")
                        {
                            _expF3.EF3_FECENVINF = dtpEnvInfCCDD.SelectedDate;
                            _expF3.EF3_NREG = txtNRegInt.Text;
                            if (dtpRecInfCCDD.SelectedDate != null)
                            {
                                if ((dtpRecInfCCDD.SelectedDate <= DateTime.Today) && (dtpRecInfCCDD.SelectedDate >= dtpEnvInfCCDD.SelectedDate))
                                {
                                    sw = true;
                                    _expF3.EF3_FECRECCD = dtpRecInfCCDD.SelectedDate;
                                }
                                else
                                    mess = "Comprobar que la fecha de recepción del informe por el CC.DD. no sea superior al día de hoy y que sea superior o igual a la fecha de envío de informe.";
                            }
                            else
                                sw = true;
                        }
                        else
                            mess = "Ha de proporcionar el Nº de Registro.";
                    }
                    else
                        mess = "Comprobar que la fecha del informe no sea superior al día de hoy y que sea superior o igual a la fecha de solicitud de informe.";
                }
                else
                    sw = true;
            }
            else
                mess = "Debe seleccionar el sentido del informe.";

            if (!sw)
                MessageBox.Show(mess, "Comprobar errores", MessageBoxButton.OK, MessageBoxImage.Error);

            return sw;
        }


        /*************************************************************************************************************************
        * Metodo: validar2
        * Recibe: boolean
        * Devuelve:   
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Este método se encarga de validar los datos introduccidos en la ventana en la segunda parte
        *************************************************************************************************************************/

        private bool validar2()
        {
            string mess = "";
            bool sw = false;

            if (dtpOrdCon.SelectedDate != null) 
            {
                if ((dtpOrdCon.SelectedDate <= DateTime.Today) && (dtpOrdCon.SelectedDate >= _expF2.EF2_FECSOLINFLET))
                {
                    _expF3.EF3_FECEVORDCONS = dtpOrdCon.SelectedDate;
                    if (dtpFirCons.SelectedDate != null)
                    {
                        if ((dtpFirCons.SelectedDate <= DateTime.Today) && (dtpFirCons.SelectedDate >= dtpOrdCon.SelectedDate))
                        {
                            sw = true;
                            _expF3.EF3_FECFIRMACONS = dtpFirCons.SelectedDate;
                        }
                        else
                            mess = "Comprobar que la fecha de Firma del Consejero no sea superior al día de hoy y que sea superior o igual a la fecha de  Orden del Consejero.";
                    }
                    else
                        sw = true;
                }
                else
                    mess = "Comprobar que la fecha de Orden del Consejero no sea superior al día de hoy y que sea superior o igual a la fecha de solicitud de informe.";
            }
            else
                sw = true;

            if (!sw)
                MessageBox.Show(mess, "Comprobar errores", MessageBoxButton.OK, MessageBoxImage.Error);

            return sw;
        }

        /*************************************************************************************************************************
        * Metodo: validar3
        * Recibe: boolean
        * Devuelve:   
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Este método se encarga de validar los datos introduccidos en la ventana en la tercera parte
        *************************************************************************************************************************/

        private bool validar3()
        {
            string mess = "";
            bool sw = false;

            if (dtpEnvInt.SelectedDate != null)
            {
                if ((dtpEnvInfCCDD.SelectedDate != null) && (dtpRecInfCCDD.SelectedDate != null) && (dtpOrdCon.SelectedDate != null))
                {
                    if ((dtpEnvInt.SelectedDate <= DateTime.Today) && (dtpEnvInt.SelectedDate >= dtpFirCons.SelectedDate) && (dtpEnvInt.SelectedDate >= dtpRecInfCCDD.SelectedDate))
                    {
                        sw = true;
                        _expF3.EF3_FECENVINTER = dtpEnvInt.SelectedDate;
                    }
                    else
                    {
                        mess = "Comprobar que la fecha de envío al interesado no sea superior al día de hoy y que sea superior ";
                        mess += "o igual a la fecha de recepción de informe en el CC.DD. y/o Firma del Consejero.";
                    }
                }
                else
                    mess = "Se tienen que tener todas las fechas rellenas para poder poner la fecha de envío al interasado.";
            }
            else
                sw = true;

            if (!sw)
                MessageBox.Show(mess, "Comprobar errores", MessageBoxButton.OK, MessageBoxImage.Error);

            return sw;
        }


        /*************************************************************************************************************************
        * Metodo: LimpiarPantalla
        * Recibe: 
        * Devuelve:  
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011 (San Leonardo de Porto Maurizio) 
        * Descripcion: Método que se utilizará para limpiar los datos una vez grabado los cambios o si se ha seleccionado otro ex_
        * pediente del grid.
        *************************************************************************************************************************/

        private void LimpiarPantalla()
        {
  
            txtNReg.Text = "";
            txtFecEntCCDD.Text = "";
            txtNifRecur.Text = "";
            txtNifRep.Text = "";
            txtNReg.Text = "";
            txtNRegInt.Text = "";
            txtNRegInt.IsReadOnly = false;
            _senInf = new TS_SENTIDOINFORME();
            cmbSenInf.IsEnabled = true;
            dtpEnvInfCCDD.SelectedDate = null;
            dtpEnvInfCCDD.IsHitTestVisible = true;
            dtpEnvInt.SelectedDate = null;
            dtpEnvInt.IsHitTestVisible = true;
            dtpFirCons.SelectedDate = null;
            dtpFirCons.IsHitTestVisible = true;
            dtpOrdCon.SelectedDate = null;
            dtpOrdCon.IsHitTestVisible = true;
            dtpRecInfCCDD.SelectedDate = null;
            dtpRecInfCCDD.IsHitTestVisible = true;
            CargarCombo();
            
        }
    }
}
