﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


namespace Recurso_Administrativo
{

    /***********************************************************************************************************************************
     *   Nombre: Principal
     *   Fecha: 10/11/2011 (San Baudolino de Alessandria)
     *   Descripción: Ventana principal de la aplicación que gestionará las diferentes opciones del menú principal
     *   Autor: José Juan Alvarado Almenara
     *********************************************************************************************************************************/

    public partial class Principal : Window
    {
        bool activada = true; //Controlar si es la primera vez que se carga la ventana

        public Principal()
        {
            InitializeComponent();
            ComprobarUsuario();  // Comprobamos que tipo de usuario se ha validado
        }

        /*************************************************************************************************************************
        * Metodo: NuevaAlta
        * Autor: José Juan Alvarado Almenara
        * Fecha: 10/11/2011 (San Baudolino de Alessandria)
        * Descripcion: Método que nos redirigirá a la ventana de altas de nuevos expedientes
        *************************************************************************************************************************/
        private void NuevaAlta(object sender, RoutedEventArgs e)
        {
            Recurso_Administrativo.Clases.Usuario _usr = new Recurso_Administrativo.Clases.Usuario();
            NuevaAlta _windNA = new NuevaAlta();
            _usr = (Recurso_Administrativo.Clases.Usuario) App.Current.Properties["Usurario"];

            _windNA.ShowDialog();
            _windNA.Owner = this;
        }

        /*************************************************************************************************************************
        * Metodo: Validar
        * Autor: José Juan Alvarado Almenara
        * Fecha: 16/11/2011 (Santa Margarita de Escocia)
        * Descripcion: Método que nos redirigirá a la ventana de Validación de Expedientes
        *************************************************************************************************************************/

        private void Validar(object sender, RoutedEventArgs e)
        {
            ValidarExpd _winVE = new ValidarExpd();
            _winVE.ShowDialog();
            _winVE.Owner = this;
        }

        /*************************************************************************************************************************
        * Metodo: SendCCDD
        * Autor: José Juan Alvarado Almenara
        * Fecha: 21/11/2011 (San Gelasio I)
        * Descripcion: Método que nos redirigirá a la ventana de Envío al Centro Directivo
        *************************************************************************************************************************/

        private void SendCCDD(object sender, RoutedEventArgs e)
        {
            EnvioCCDD _winSendCCDD = new EnvioCCDD();
            _winSendCCDD.ShowDialog();
            _winSendCCDD.Owner = this;
        }

        /*************************************************************************************************************************
        * Metodo: menFase2_Click
        * Autor: José Juan Alvarado Almenara
        * Fecha: 22/11/2011 (Santa Cecilia, patrona de la música)
        * Descripcion: Método que nos redirigirá a la ventana de Fase 2
        *************************************************************************************************************************/

        private void menFase2_Click(object sender, RoutedEventArgs e)
        {
            Fase2 _winFase2 = new Fase2();
            _winFase2.ShowDialog();
            _winFase2.Owner = this;
        }

        /*************************************************************************************************************************
        * Metodo: menFase3_Click
        * Autor: José Juan Alvarado Almenara
        * Fecha: 25/11/2011
        * Descripcion: Método que nos redirigirá a la ventana de Fase 3
        *************************************************************************************************************************/

        private void menFase3_Click(object sender, RoutedEventArgs e)
        {
            Fase3 _winFase3 = new Fase3();
            _winFase3.ShowDialog();
            _winFase3.Owner = this;
        }

        /*************************************************************************************************************************
        * Metodo: menConsul_Click
        * Autor: José Juan Alvarado Almenara
        * Fecha: 28/11/2011 (San Santiago de la Marca) 
        * Descripcion: Método que nos redirigirá a la ventana de Consultas
        *************************************************************************************************************************/

        private void menConsul_Click(object sender, RoutedEventArgs e)
        {
            Consultas _winConsult = new Consultas();
            _winConsult.ShowDialog();
            _winConsult.Owner = this;
        }

        /*************************************************************************************************************************
         * Metodo: menExit_Click
         * Autor: José Juan Alvarado Almenara
         * Fecha: 10/11/2011
         * Descripcion: Método que nos permitirá salir de la aplicación
         *************************************************************************************************************************/

        private void menExit_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        /*************************************************************************************************************************
         * Metodo:  WPrincipal_Activated
         * Autor: José Juan Alvarado Almenara
         * Fecha: 02/12/2011
         * Descripcion: Método que nos permitirá visualizar los expedientes proximos a vencer
         *************************************************************************************************************************/

        private void WPrincipal_Activated(object sender, EventArgs e)
        {
            if ((activada) && (menValidar.IsEnabled == true) && (menAltas.IsEnabled == true)) // si no hemos entrado antes y tiene activado el menu validar (es Letrado)
            {
                ProxCaducarServicio _prxCadSrv = new ProxCaducarServicio();
                if (_prxCadSrv.getProxCaducar().Count() > 0)  // Comprobamos si hay expedientes proximos a caducar
                {
                    ProximosCaducar _WproxCad = new ProximosCaducar();
                    _WproxCad.Show();
                }
                activada = false; 
            }

        }

        /*************************************************************************************************************************
        * Metodo: ComprobarUsuario
        * Recibe:
        * Devuelve:
        * Autor: José Juan Alvarado Almenara
        * Fecha: 10/11/2011
        * Descripcion: Este método se utilizará para realizar comprobociones del tipo de usuario que se valida y determinar que 
        * opciones del menú se mostrarán.
        *************************************************************************************************************************/

        private void ComprobarUsuario()
        {
            //Creamos el objeto usuario
            Recurso_Administrativo.Clases.Usuario _usr = new Recurso_Administrativo.Clases.Usuario();
            //Rcupepermos el usuario que se ha validado de la "Variable global"
            _usr = (Recurso_Administrativo.Clases.Usuario)App.Current.Properties["Usurario"];

            if (_usr.ccdd != 1) // No pertenece a la SGT
            {
                menAltas.IsEnabled = false; // no puede realizar las altas
                menFase3.IsEnabled = false; // y no puede realizar actualizaciones fase 3
            }
            else // Es que pertenece a la SGT puede realizar altas pero...
            {
                if (_usr.tipUsr.Equals("Administrativo")) // si es administrativo no puede realizar validaciones
                    menValidar.IsEnabled = false;
            }
        }


     
    }  
}
