﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Recurso_Administrativo.Clases;
using Recurso_Administrativo.Persistencia;


namespace Recurso_Administrativo
{
    /***********************************************************************************************************************************
    *   Nombre: ResulConsulta
    *   Fecha: 01/12/2011 (San Eloy) 
    *   Descripción: Ventana para mostrar los datos del expediente seleccionado en el grid de consultas
    *   Autor: José Juan Alvarado Almenara
    *********************************************************************************************************************************/

    public partial class ResulConsulta : Window
    {
        T_TERCEROS _terRec = new T_TERCEROS();
        T_TERCEROS _terRep = new T_TERCEROS();

        public ResulConsulta()
        {
            InitializeComponent();
            CargarCombos();
            mostrar();
        }

        // Cargamos los combos //
        private void CargarCombos()
        {
            TipoRecursoServicio _trs = new TipoRecursoServicio();
            CCDDServicio _ccddServ = new CCDDServicio();
            TipoEstExpSer _desSer = new TipoEstExpSer();
            SentInfServ _SenInfSrv = new SentInfServ();

            cmbTipRecur.ItemsSource = _trs.getTipRec();
            cmbTipRecur.SelectedValue = "TR_CLAVE";
            cmbTipRecur.DisplayMemberPath = "TR_DESC";

            cmbCCDD.ItemsSource = _ccddServ.getCCDD();
            cmbCCDD.SelectedValue = "CD_CLAVE";
            cmbCCDD.DisplayMemberPath = "CD_DESC";

            cmbEstExp.ItemsSource = _desSer.getDesAll();
            cmbEstExp.SelectedValue = "DE_CLAVE";
            cmbEstExp.DisplayMemberPath = "DE_DESC";

            cmbSenInf.ItemsSource = _SenInfSrv.getSentInf().ToList();
            cmbSenInf.SelectedValue = "SI_CLAVE";
            cmbSenInf.DisplayMemberPath = "SI_DESC";
        }

        //Cargamos los datos a mostrar //

        private void mostrar()
        {
            V_Todos _ExpCon = new V_Todos();
            TercerosServicio _terSer = new TercerosServicio();
            UsuarioServicio _usrSer = new UsuarioServicio();

            T_USUARIO _usr = new T_USUARIO();

            _ExpCon = (V_Todos)App.Current.Properties["ExpCon"];
            _terRec = _terSer.getTerceroId(_ExpCon.EF1_TER_REC_CF);
            _terRep = _terSer.getTerceroId(Convert.ToInt32(_ExpCon.EF1_TER_REP_CF));
            _usr = _usrSer.getUsrID(Convert.ToInt32(_ExpCon.EF1_USR_VAL_CF));

            //FASE 1//

            txtNReg.Text = _ExpCon.EF1_NUMREG;
            cmbTipRecur.SelectedIndex = _ExpCon.EF1_TR_CF - 1;
            dtpFecRegCons.SelectedDate = _ExpCon.EF1_FECREGCON;
            dtpFecRegOtros.SelectedDate = _ExpCon.EF1_FECREGOTROS;
            dtpFecInicio.SelectedDate = _ExpCon.EF1_FECINI;
            txtNifRecur.Text = _terRec.TER_NIF;
            txtNifRep.Text = (_terRep == null ? "" : _terRep.TER_NIF);
            txtValidado.Text = (_usr == null ? "" : _usr.USR_NOMBRE + " " + _usr.USR_APELLIDOS);
            dptFecEnvNot.SelectedDate = _ExpCon.EF1_FECENVCARTA;
            cmbCCDD.SelectedIndex = Convert.ToInt32(_ExpCon.EF1_CD_CF) - 1;
            txtNRegInt.Text = _ExpCon.EF1_NREGINT;
            dtpFecSendCCDD.SelectedDate = _ExpCon.EF1_FECENVCD;
            dtpFecRecCCDD.SelectedDate = _ExpCon.EF1_FECRECCD;

            //FASE 2//

            cmbEstExp.SelectedIndex = Convert.ToInt32(_ExpCon.EF2_DE_CF) - 1;
            txtDocReq.Text = _ExpCon.EF2_OBSERVACIONES;
            dtpEnvSolDoc.SelectedDate = _ExpCon.EF2_FECSOLDAT;
            dtpNotSolDoc.SelectedDate = _ExpCon.EF2_FECNOTSOLDAT;
            dtpFinPlaEntDoc.SelectedDate = _ExpCon.EF2_FECFINPLAZODOC;
            dtpSolInfLet.SelectedDate = _ExpCon.EF2_FECSOLINFLET;
            txtNRegIntF2.Text = _ExpCon.EF2_NREGINT;
            dtpFinPlaInfLet.SelectedDate = _ExpCon.EF2_FECFINPLAZOINF;

            // FASE 3 //

            cmbSenInf.SelectedIndex = Convert.ToInt32(_ExpCon.EF3_SI_CF) - 1;
            dtpEnvInfCCDD.SelectedDate = _ExpCon.EF3_FECENVINF;
            txtNregInt.Text = _ExpCon.EF3_NREG;
            dtpRecInfCCDD.SelectedDate = _ExpCon.EF3_FECRECCD;
            dtpOrdCon.SelectedDate = _ExpCon.EF3_FECEVORDCONS;
            dtpFirCons.SelectedDate = _ExpCon.EF3_FECFIRMACONS;
            dtpEnvInt.SelectedDate = _ExpCon.EF3_FECENVINTER;
        }

        // Si pinchamos sobre el NIF del recurrente llamamos a la ventana de tercero y mostramos los datos del recurrente //

        private void txtNifRecur_PreviewMouseUp(object sender, MouseButtonEventArgs e)
        {
            App.Current.Properties["Terceros"] = 3;
            App.Current.Properties["_terc"] = _terRec;

            AltasTerceros _WAltaTerc = new AltasTerceros();
            _WAltaTerc.ShowDialog();
            _WAltaTerc.Owner = this;
        }

        // Si pinchamos sobre el NIF del representante llamamos a la ventana de tercero y mostramos los datos del representante //

        private void txtNifRep_PreviewMouseUp(object sender, MouseButtonEventArgs e)
        {
            App.Current.Properties["Terceros"] = 4;
            App.Current.Properties["_terc"] = _terRep;

            AltasTerceros _WAltaTerc = new AltasTerceros();
            _WAltaTerc.ShowDialog();
            _WAltaTerc.Owner = this;

        }

    }
}
