﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
// Las siguientes importaciones van a ser generales para todo el proyecto.
using Recurso_Administrativo.Persistencia; //Importamos todas las clases de la persitencia. Mapeo a las tablas de la BBDD
using Recurso_Administrativo.Clases; // Importamos todas las clases necesarios para el correcto funcionamiento de la aplicación. 

namespace Recurso_Administrativo
{
    /***********************************************************************************************************************************
     *   Nombre: MainWindow (Validación)
     *   Fecha: 07/11/2011 (San Prosdócimo de Padua)
     *   Descripción: Ventana de validación de los usuarios que intentan acceder a la aplicación de Recursos Administrativos
     *   Autor: José Juan Alvarado Almenara
     ***********************************************************************************************************************************/
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();            
        }

        /*************************************************************************************************************************
        * Metodo: btnCancel
        * Autor: José Juan Alvarado Almenara
        * Fecha: 07/11/2011 (San Prosdócimo de Padua)
        * Descripcion: Método del sistema que controla el evento click del boton de cancelar y produce una salida de la aplicación
        *************************************************************************************************************************/

        private void btnCancel_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        /*************************************************************************************************************************
        * Metodo: btnSend
        * Autor: José Juan Alvarado Almenara
        * Fecha: 07/11/2011 (San Prosdócimo de Padua)
        * Descripcion: Metodo del sistema que controla la pulsación del botón enviar. Con la pulsación de éste boton se realizan
        * una serie de comprobaciones en la base de datos, sobre todo en la tabla de usuario para comprobar la existencia de éste
        * (usuario) en la base de datos y premitir el acceso al resto de la aplicación
        *************************************************************************************************************************/

        private void btnSend_Click(object sender, RoutedEventArgs e)
        {
            UsuarioServicio _usrSev = new UsuarioServicio();  // Creamos el objeto que realiza la conexion y consulta a la BBDD.

            if((txtUsr.Text.Trim() =="") || (pswBox.Password.ToString().Trim() =="")) //Si han dejado en blanco el usr y pass
            {
                lblError.Content = "Error. Falta rellenar el usuario o la contraseña."; // Mostramos el mensaje de error
                lblError.Visibility = Visibility.Visible;
            }
            Usuario _usr = _usrSev.getUsr(txtUsr.Text, pswBox.Password.ToString()); //LLamamos a la consulta para obtener el objeto usuario
            if (_usr == null) // Si no obtenemos nada informamos del error
            {
                lblError.Content = "Usuario o Contraseña incorrecta.";
                lblError.Visibility = Visibility.Visible;
            }
            else // en caso contrario hemos tenido éxito 
            {
                App.Current.Properties["Usurario"] = _usr; //Guardamos el objeto Usuario en una "variable global" 
                Principal _principal = new Principal(); // y creamos y mostramos la ventana principal
                _principal.Show();
                this.Close(); // Por último cerramos la ventana de validación
            }
        }
    }
}
